clear all
close all
clc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% TP 10 Solution (With MFE Sheppard Toolbox)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Preestimation Analysis
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load TP10.mat

Y=Y1;

scrsz=get(0,'ScreenSize');
figure('Position',[.1*scrsz(3) .5*scrsz(4) .6*scrsz(3) .3*scrsz(4)])
subplot(1,2,1)
autocorr(Y)
title('Y1 ACF')
subplot(1,2,2)
parcorr(Y)
title('Y1 PACF')


[coeff,LLF,residuals,SEregression,diagnostics, robustSE,stderrors,likelihoods]=armaxfilter(Y,1,1,0);
fprintf('\n++++++++++++++++++++++++++++++++++++++++++++++++++++++\n')
fprintf('ARMA coefs:\n')
fprintf('++++++++++++++++++++++++++++++++++++++++++++++++++++++\n')
[coeff'; sqrt(diag(robustSE))']

fprintf('\n++++++++++++++++++++++++++++++++++++++++++++++++++++++\n')
fprintf('lbqtest:\n')
fprintf('++++++++++++++++++++++++++++++++++++++++++++++++++++++\n')
[H,pValue,Stat,CriticalValue]=lbqtest(residuals,[5 10 15 20]',0.05);
[H  pValue  Stat  CriticalValue]

figure('Position',[.1*scrsz(3) .1*scrsz(4) .6*scrsz(3) .3*scrsz(4)])
subplot(1,2,1)
autocorr(residuals.^2)
title('Y1 Squared residuals ACF')
subplot(1,2,2)
parcorr(residuals.^2)
title('Y1 Squared residuals PACF')

fprintf('\n++++++++++++++++++++++++++++++++++++++++++++++++++++++\n')
fprintf('ARCH test on residuals of ARMA:\n')
fprintf('++++++++++++++++++++++++++++++++++++++++++++++++++++++\n')
% [H,pValue,Stat,CriticalValue]=archtest(residuals,[5 10 15 20]',0.05);
% [H pValue Stat CriticalValue]

 [LM,PVAL]=lmtest1(residuals.^2,10)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Parameter estimation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 [coeff2,LL,ht,VCVROBUST,VCV,SCORES,DIAGNOSTICS]=tarch(residuals,1,0,0);
 std_deviations=diag(VCVROBUST);
 t_stats=coeff2./std_deviations;
[coeff2 std_deviations t_stats]
    

stdandardized_residuals=residuals./(ht.^0.5);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Postestimation Analysis
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure('Position',[.2*scrsz(3) .2*scrsz(4) .6*scrsz(3) .3*scrsz(4)])
subplot(1,2,1)
autocorr(stdandardized_residuals.^2)
title('Y1 Squared GARCH residuals ACF')
subplot(1,2,2)
parcorr(stdandardized_residuals.^2)
title('Y1 Squared GARCH residuals PACF')

fprintf('\n++++++++++++++++++++++++++++++++++++++++++++++++++++++\n')
fprintf('ARCH test on standardised residuals of ARMA-GARCH:\n')
fprintf('++++++++++++++++++++++++++++++++++++++++++++++++++++++\n')

 [LM,PVAL]=lmtest1(stdandardized_residuals.^2,10)




 
 


